/*
   When I was trying to find out if I could put a tcl/tk interface
   on a plain old stdin/stdout C program I found that there were no
   good examples on the net, moreover my thoughts on how tcl/tk
   would handle the problem was completely wrong.  Ultimately I got
   some sample programs from Noelle Adam and I saw the light.  The
   way the "game is played" is the following:
  
   1) Start your C program off as usual plus do the initializations
      for the tcl/tk program.

   2) Call the function Tk_MainLoop, this lands you in the Tcl/Tk
      program.

   3) Once inside the Tcl/Tk program you need to call some home-made
      C functions to get things running in your C program.  In the
      following example the home-made C function setvar is called to
      send commands back into the C program.  Once you land in the
      C function you can call up the rest of your C program to do
      whatever.

   In this exaple note that my philosophy on comments is that programs
   should be self-documenting, comments can actually get in the way
   of seeing the overall plan.

   This program works under Linux and may not work elsewhere.
*/

#include <stdio.h>
#include <tcl.h>
#include <tk.h>

Tcl_Interp *interp;
int a, b, c, code, i;
char cmd[257];
char str[257];
char *val;

int setvar(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
 strcpy(cmd,argv[1]);
 if (cmd[0] == 'a') a = cmd[2];
 else if (cmd[0] == 'b') b = cmd[2];
 else if (cmd[0] == 'c') c = cmd[2];
 else
  {
   printf("That's all folks!!!\n");
   Tcl_Eval(interp,"exit");
  };
 val = Tcl_GetVar(interp,"i",0);
 sscanf(val,"%d",&i);
 Tcl_Eval(interp,"upandout");
 sprintf(str,".textarea.can create text 10 75 -text \"cmd = %s, a = %c, b = %c, c = %c tag (i) = %d\" -anchor nw -font vga -tags %d",cmd,a,b,c,i,i);
 Tcl_Eval(interp,str);
 return TCL_OK;
}

void main()

{
 interp = Tcl_CreateInterp();

 if (Tcl_Init(interp) == TCL_ERROR)
    {
     printf("Tcl_Init failed: %s\n", interp->result);
     exit(1);
    };

 if (Tk_Init(interp) == TCL_ERROR)
    {
     printf("Tk_Init failed: %s\n", interp->result);
     exit(1);
    };

 code = Tcl_EvalFile(interp, "interface.tcl"); 
 if (code != TCL_OK)
  {
   printf("error number: %d\n",code);
   exit(1);
  };

 Tcl_CreateCommand(interp, "setvar",setvar,(ClientData) NULL,(Tcl_CmdDeleteProc *)NULL);

 a = '1';
 b = '2';
 c = '3';

 Tk_MainLoop();
}
