# The following example puts some text up on the screen.  When used
# in conjunction with the C program the C program will write some
# information to the canvas area, this information shows the values
# of variables within the C program.  This is an early effort and
# is in need of more work in order to turn it into a useful component
# of a real program but it still illustrates a lot of basic tcl/tk.

set i 0
set linenumber 0

# the following proc deletes the line at the top of the screen and
# shifts everything else up.

proc upandout { } {
global i
 incr i 1
 .textarea.can delete $i
 .textarea.can move all 0 -15
}

# Display a fixed initial batch of text.  This is rather poor in that
# it only displays the original text, not any text added from the
# interaction with the C program, that's the next feature to add.

proc displaytext FONT {
global linenumber
global i
.textarea.can delete all
set linenumber 0
set i 0
.textarea.can create text 10 0 -text "Line 1" -anchor nw -font $FONT -tags $linenumber
incr linenumber 1
.textarea.can create text 10 15 -text "Line 2" -anchor nw -font $FONT -tags $linenumber
incr linenumber 1
.textarea.can create text 10 30 -text "Line 3" -anchor nw -font $FONT -tags $linenumber
incr linenumber 1
.textarea.can create text 10 45 -text "123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890" -anchor nw -font $FONT -tags $linenumber
incr linenumber 1
.textarea.can create text 10 60 -text "Line 5" -anchor nw -font $FONT -tags $linenumber
incr linenumber 1
.textarea.can create text 10 75 -text "This is the last line."  -anchor nw -font $FONT -tags $linenumber
}

frame .f
menubutton .f.file -text "File" -menu .f.file.z
menu .f.file.z
.f.file.z add command -label "Exit from C" -command { setvar "q" }
.f.file.z add separator
.f.file.z add command -label "Exit from Tcl/Tk" -command exit

# When you change fonts the original lines given in displaytext go up
# not any new lines that came from interaction with the C program.

menubutton .f.fonts -text "Fonts" -menu .f.fonts.z
menu .f.fonts.z
.f.fonts.z add command -label "Lucida" -command { displaytext -b&h-lucidatypewriter-medium-r-normal-sans-18-180-75-75-m-110-iso8859-1 }
.f.fonts.z add separator
.f.fonts.z add command -label "VGA" -command { displaytext vga }

# The setvar function is defined in interface.cpp.  Defining functions
# in C that you call from here is your way to get back into the C
# program.

menubutton .f.cmds -text "Commands" -menu .f.cmds.z
menu .f.cmds.z
.f.cmds.z add command -label "a = 1" -command { setvar "a 1"  }
.f.cmds.z add separator
.f.cmds.z add command -label "a = 2" -command { setvar "a 2"  }
.f.cmds.z add separator
.f.cmds.z add command -label "a = 3" -command { setvar "a 3"  }
.f.cmds.z add separator
.f.cmds.z add command -label "b = 1" -command { setvar "b 1"  }
.f.cmds.z add separator
.f.cmds.z add command -label "b = 2" -command { setvar "b 2"  }
.f.cmds.z add separator
.f.cmds.z add command -label "b = 3" -command { setvar "b 3"  }
.f.cmds.z add separator
.f.cmds.z add command -label "c = 1" -command { setvar "c 1"  }
.f.cmds.z add separator
.f.cmds.z add command -label "c = 2" -command { setvar "c 2"  }
.f.cmds.z add separator
.f.cmds.z add command -label "c = 3" -command { setvar "c 3" }

pack .f.file .f.fonts .f.cmds -side left

frame .textarea -relief sunken
scrollbar .textarea.hsb  -relief sunken -orient horiz -command ".textarea.can xview"
canvas .textarea.can -width 600 -height 120 -xscrollcommand ".textarea.hsb set" -scrollregion { 0 0 800 120 } -relief sunken
pack .textarea.can -side top
pack .textarea.hsb -side top -fill x
pack .textarea .f -side bottom

displaytext vga
